/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.test.webservice.jbws165;

// $Id$

import javax.naming.InitialContext;
import javax.xml.namespace.QName;
import javax.xml.rpc.Service;

import junit.framework.Test;

import org.jboss.test.webservice.WebserviceTestBase;

/**
 * Tests <context-root> and <port-component-root> elements in EJB endpoints
 * 
 * @author Thomas.Diesler@jboss.org
 * @since 10-Jun-2005
 */
public class JBWS165TestCase extends WebserviceTestBase
{
   /**
    * Construct the test case with a given name
    */
   public JBWS165TestCase(String name)
   {
      super(name);
   }

   /** Deploy the test */
   public static Test suite() throws Exception
   {
      return getDeploySetup(JBWS165TestCase.class, "ws4ee-jbws165.ear");
   }

   public void testNone() throws Exception
   {
      InitialContext iniCtx = getClientContext();
      Service service = (Service) iniCtx.lookup("java:comp/env/service/HelloNone");
      Hello port = (Hello) service.getPort(Hello.class);
      String retObj = port.hello(getName());
      assertEquals(getName(), retObj);
   }
   
   public void testPortComponentURIOne() throws Exception
   {
      InitialContext iniCtx = getClientContext();
      Service service = (Service) iniCtx.lookup("java:comp/env/service/HelloPCOne");
      QName portName = new QName("http://org.jboss.test.webservice/jbws165", "HelloPortOne");
      Hello port = (Hello) service.getPort(portName, Hello.class);
      String retObj = port.hello(getName());
      assertEquals(getName(), retObj);
   }
   
   public void testPortComponentURITwo() throws Exception
   {
      InitialContext iniCtx = getClientContext();
      Service service = (Service) iniCtx.lookup("java:comp/env/service/HelloPCTwo");
      QName portName = new QName("http://org.jboss.test.webservice/jbws165", "HelloPortTwo");
      Hello port = (Hello) service.getPort(portName, Hello.class);
      String retObj = port.hello(getName());
      assertEquals(getName(), retObj);
   }
   
   public void testContextRoot() throws Exception
   {
      InitialContext iniCtx = getClientContext();
      Service service = (Service) iniCtx.lookup("java:comp/env/service/HelloContextRoot");
      Hello port = (Hello) service.getPort(Hello.class);
      String retObj = port.hello(getName());
      assertEquals(getName(), retObj);
   }
   
   public void testBoth() throws Exception
   {
      InitialContext iniCtx = getClientContext();
      Service service = (Service) iniCtx.lookup("java:comp/env/service/HelloBoth");
      Hello port = (Hello) service.getPort(Hello.class);
      String retObj = port.hello(getName());
      assertEquals(getName(), retObj);
   }
}
